Unit SF86R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure SF86R(RM :Real; VARS :Real; N :Integer;
                var X :Array of Real; X0 :Real; var P :Array of Real);

implementation

procedure SF86R(RM :Real; VARS :Real; N :Integer;
                var X :Array of Real; X0 :Real; var P :Array of Real);
var
I,J,K,IJ,K1 :Integer;
U,SUM,SUM1,SUM2,Z1,Z2,R :Real;
label
_10,_20,_30,_40,_50,_60;
begin
K := Trunc( IntPower(RM-X0,2)/VARS );
U := K/(RM-X0);
SUM := 0.0;
for I:=1 to N do
 begin
  SUM1 := 1.0;
  SUM2 := 1.0;
  IJ := 1;
  if ( I <> 1 ) 
   then goto _10;
  Z1 := 0.0;
  goto _20;
_10:
  Z1 := U*(X[I-2]-X0);
_20:
  Z2 := U*(X[I-1]-X0);
  K1 := K-1;
  for J:=1 to K1 do
   begin
    IJ := IJ*J;
    SUM1 := SUM1+IntPower(Z1,J)/IJ;
    SUM2 := SUM2+IntPower(Z2,J)/IJ;
_30:
   end;
  if ( I <> 1 ) 
   then goto _40;
  P[0] := SUM1-SUM2*Exp(-U*(X[I-1]-X0));
  goto _50;
_40:
  P[I-1] := SUM1*Exp(-U*(X[I-2]-X0))-
    SUM2*Exp(-U*(X[I-1]-X0));
_50:
  SUM := SUM+P[I-1];
_60:
 end;
P[N+0] := 1.0-SUM;
end;

end.
